/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector<int > look_for_square(vector<vector<char> > matrix, int x, int y)
{
    int a = 0;
    for(int i = x - 1; i < matrix.size(); i++) {
        if (matrix[y-1][i] == *"#") {
            a++;
        } else if (matrix[y-1][i] == *".") {break;}
    }
    int x1 = x + a - 1;
    int y1 = y + a - 1;
    vector<int> coords(4);
    coords[0] = x;
    coords[1] = y;
    coords[2] = x1;
    coords[3] = y1;

    cout << x << " " << y << " " << x1 << " " << y1 << endl;

    return coords;
}

int main() {
    ifstream fin("squares.in");
    int n;
    fin >> n;
    vector<vector<char> > paper(n, vector<char>(n));
    vector<int> square1(4);
    vector<int> square2(4);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            fin >> paper[i][j];
        }
    }

        bool broken = false;
    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < n - 1; j++) {
            if (paper[j][i] == *"#" && paper[j+1][i] == *"#" && !broken) {
                square1 = look_for_square(paper, i+1, j+1);
                broken = true;
            }
        }
    }

        broken = false;
   for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j < n - 1; j++) {
            if (paper[i][j] == *"#" && paper[i][j+1] == *"#" && !broken) {
                square2 = look_for_square(paper, j+1, i+1);
                broken = true;
            }
        }
    }

    ofstream fout("squares.out");

    for (int i = 0; i < square1.size(); i++) {
        fout << square1[i] << " ";
    }
    fout << endl;

    for (int i = 0; i < square2.size(); i++) {
        fout << square2[i] << " ";
    }
    fout << endl;

    return 0;
}
