/* GCC */

#include <stdio.h>
#include <math.h>

using namespace std;

int prime[5][2], nprime = 0;

bool findprime(int &n)
{
    int k;
    k = ceil(sqrt(n));
    for (int i = 2; i <= k; i++)
    {
        if (n % i == 0)
        {
            if (i > 7)
                return false;
            n /= i;
            prime[nprime][0] = i;
            prime[nprime][1] = 1;
            nprime++;
        }
        while (n % i == 0)
        {
            n /= i;
            prime[nprime - 1][1]++;
        }
    }
    if (n != 1)
    {
        if (n > 7)
            return false;
        prime[nprime][0] = n;
        prime[nprime][1] = 1;
        nprime++;
    }
    return true;
}

int main()
{
    freopen("awesome.in", "r", stdin);
    freopen("awesome.out", "w", stdout);
    int d, d1, sum = 0;
    scanf("%d", &d);
    d1 = d;
    if (!findprime(d1))
        printf("0");
    else
    {
        for (int i = nprime - 1; i >= 0; i--)
        {
            sum += prime[i][0] * prime[i][1];
            for (int j = 0; j < prime[i][1]; j++)
                printf("%d", prime[i][0]);
        }
        for (int i = 0; i < d - sum; i++)
            printf("1");
    }
    printf("\n");
    return 0;
}
