/* GCC */

#define maxn 1000

#include <stdio.h>
#include <algorithm>

using namespace std;

int hor[4][3], ver[4][3], a[1000][1000], coord[2][2][2]; //coord: square-vertice-x/y

int horln; //0 - no line, 1 - first #, 2 = more than one #

int checkdir(int x, int y) //-1 up, 1 down
{
    if (a[x][y - 1] == 1)
        return -1;
    else
        return 1;
}

int main()
{
    freopen("squares.in", "r", stdin);
    freopen("squares.out", "w", stdout);
    int n, nhor = 0;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
    {
        horln = 0;
        int x = 0; // y = i;
        while (x < n)
        {
            char c;
            scanf("%c", &c);
            if (c == 46)
            {
                horln = 0;
                a[x][i] = 0;
                x++;
            }
            if (c == 35) //the fun begins
            {
                a[x][i] = 1;
                switch (horln)
                {
                    case 0: horln++;
                            break;
                    case 1: horln++;
                            break;
                    case 2: horln++;
                            hor[nhor][0] = x - 2;
                            hor[nhor][1] = i;
                            hor[nhor][2] = 3;
                            nhor++;
                            break;
                    case 3: hor[nhor - 1][2]++;
                            break;
                }
                x++;
            }
        }
    }
    int side, k;
    if (nhor == 3)
    {
        if ((a[hor[1][0] + 1][hor[1][1] + 1] == 1) ||  (a[hor[1][0] + 1][hor[1][1] - 1] == 1)) //fiendish
            {
                hor[1][0]++;
                hor[1][2]--;
            }
        if ((a[hor[1][0] + hor[1][2] - 2][hor[1][1] + 1] == 1) || a[hor[1][0] + hor[1][2] - 2][hor[1][1] - 1] == 1) //??
            hor[1][2]--;
    }
    if ((nhor == 4) && (hor[0][1] + 1 == hor[1][1]) && (hor[2][1] + 1 == hor[3][1]) && (abs(hor[1][0] - hor[0][0]) <= 1))
    {
        hor[1][0]++;
        hor[1][2] -= 2;
        hor[2][0]++;
        hor[2][2] -= 2;
    }
    switch (nhor)
    {
        case 2:
                side = hor[1][1] - hor[0][1] + 1; //medium
                coord[0][0][0] = hor[0][0] + 1;     // _ _
                coord[0][0][1] = hor[0][1] + 1;     //|_|_| or similar
                coord[0][1][0] = hor[0][0] + side;
                coord[0][1][1] = hor[0][1] + side;
                coord[1][0][0] = hor[0][0] + hor[0][2] - side + 1;
                coord[1][0][1] = hor[0][1] + 1;
                coord[1][1][0] = hor[1][0] + hor[1][2];
                coord[1][1][1] = hor[1][1] + 1;
                break;
        case 3:                         //hard
                if ((hor[0][2] == hor[1][2]) && (hor[1][2] == hor[2][2])) //moderately hard
                {
                    coord[0][0][0] = hor[0][0] + 1;
                    coord[0][0][1] = hor[0][1] + 1;
                    coord[0][1][0] = hor[0][0] + hor[0][2]; // _
                    coord[0][1][1] = hor[0][1] + hor[0][2]; //|_|
                    coord[1][0][0] = hor[1][0] + 1;         //|_|
                    coord[1][0][1] = hor[1][1] + 1;
                    coord[1][1][0] = hor[1][0] + hor[1][2];
                    coord[1][1][1] = hor[1][1] + hor[1][2];
                    break;
                }
                if ((hor[0][2] == hor[1][2]) || (hor[1][2] == hor[2][2])) //extreme
                {
                    coord[0][0][0] = hor[0][0] + 1;         // ___
                    coord[0][0][1] = hor[0][1] + 1;         //|   |
                    coord[0][1][0] = hor[0][0] + hor[0][2]; //|___| or upside down
                    coord[0][1][1] = hor[0][1] + hor[0][2]; //|_|
                    coord[1][0][0] = hor[2][0] + 1;
                    coord[1][0][1] = hor[1][1] + 1;
                    coord[1][1][0] = hor[2][0] + hor[2][2];
                    coord[1][1][1] = hor[1][1] + hor[2][2];
                    break;
                }
                if (hor[0][2] == hor[2][2]) //insane
                {
                    coord[0][0][0] = hor[0][0] + 1;
                    coord[0][0][1] = hor[0][1] + 1;
                    coord[0][1][0] = hor[0][0] + hor[0][2];
                    coord[0][1][1] = hor[0][1] + hor[0][2];
                    int dir;
                    if (hor[1][1] - hor[0][1] == hor[2][1] - hor[1][1]) //evil
                        {
                            if (hor[1][0] == hor[0][0])
                                dir = checkdir(hor[1][0] + hor[1][2] - 1, hor[1][1]); //-1?
                            else
                                dir = checkdir(hor[1][0], hor[1][1]);
                        }
                    else
                    {
                        if (hor[1][1] - hor[0][1] == hor[1][2] - 1)
                            dir = -1;
                        else
                            dir = 1;
                    }
                    if (dir == -1)
                    {
                        coord[1][0][0] = hor[1][0] + 1;
                        coord[1][0][1] = hor[0][1] + 1;
                        coord[1][1][0] = hor[1][0] + hor[1][2];
                        coord[1][1][1] = hor[1][1] + 1;
                    }
                    else
                    {
                        coord[1][0][0] = hor[1][0] + 1;
                        coord[1][0][1] = hor[1][1] + 1;
                        coord[1][1][0] = hor[1][0] + hor[1][2];
                        coord[1][1][1] = hor[2][1] + 1;
                    }
                    break;
                }
                //and so we've come to the final one
                if ((hor[0][2] > hor[1][2]) && (hor[0][2] > hor[2][2])) //excruciating
                {
                    coord[0][0][0] = hor[1][0] + 1;
                    coord[0][0][1] = hor[0][1] + 1;
                    coord[0][1][0] = hor[1][0] + hor[1][2];
                    coord[0][1][1] = hor[1][1] + 1;
                    coord[1][0][0] = hor[2][0] + 1;
                    coord[1][0][1] = hor[0][1] + 1;
                    coord[1][1][0] = hor[2][0] + hor[2][2];
                    coord[1][1][1] = hor[2][1] + 1;
                }
                if ((hor[1][2] > hor[0][2]) && (hor[1][2] > hor[2][2]))
                {
                    coord[0][0][0] = hor[0][0] + 1;
                    coord[0][0][1] = hor[0][1] + 1;
                    coord[0][1][0] = hor[0][0] + hor[0][2];
                    coord[0][1][1] = hor[1][1] + 1;
                    coord[1][0][0] = hor[2][0] + 1;
                    coord[1][0][1] = hor[1][1] + 1;
                    coord[1][1][0] = hor[2][0] + hor[2][2];
                    coord[1][1][1] = hor[2][1] + 1;
                }
                if ((hor[2][2] > hor[0][2]) && (hor[2][2] > hor[1][2]))
                {
                    coord[0][0][0] = hor[0][0] + 1;
                    coord[0][0][1] = hor[0][1] + 1;
                    coord[0][1][0] = hor[0][0] + hor[0][2];
                    coord[0][1][1] = hor[2][1] + 1;
                    coord[1][0][0] = hor[1][0] + 1;
                    coord[1][0][1] = hor[1][1] + 1;
                    coord[1][1][0] = hor[1][0] + hor[1][2];
                    coord[1][1][1] = hor[2][1] + 1;
                }
                break;
        case 4:
                coord[0][0][0] = hor[0][0] + 1; //easy
                coord[0][0][1] = hor[0][1] + 1;
                coord[0][1][0] = hor[0][0] + hor[0][2];
                coord[0][1][1] = hor[0][1] + hor[0][2];
                k = 1;
                while ((hor[k][0] == hor[0][0]) && (hor[k][1] == hor[0][1] + hor[0][2] - 1))
                    k++;
                coord[1][0][0] = hor[k][0] + 1;
                coord[1][0][1] = hor[k][1] + 1;
                coord[1][1][0] = hor[k][0] + hor[k][2];
                coord[1][1][1] = hor[k][1] + hor[k][2];
                break;
        default: //just in case
                coord[0][0][0] = hor[0][0] + 1;
                coord[0][0][1] = hor[0][1] + 1;
                coord[0][1][0] = hor[0][0] + hor[0][2];
                coord[0][1][1] = hor[0][1] + hor[0][2];
                int side2 = hor[1][2] > hor[2][2] ? hor[2][2] : hor[1][2];
                coord[1][0][0] = side2 + (hor[1][2] > hor[2][2] ? hor[2][0] : hor[1][0]);
                coord[1][0][1] = hor[2][1] - side2 + 2; //?
                coord[1][1][0] = hor[2][0] + side2;
                coord[1][1][1] = hor[2][1] + 1;
    }
    if (coord[0][0][0] > coord[1][0][0])
                {
                    swap(coord[0][0][0], coord[1][0][0]);
                    swap(coord[0][0][1], coord[1][0][1]);
                    swap(coord[0][1][0], coord[1][1][0]);
                    swap(coord[0][1][1], coord[1][1][1]);
                }
    printf("%d %d %d %d\n", coord[0][0][0], coord[0][0][1], coord[0][1][0], coord[0][1][1]);
    printf("%d %d %d %d\n", coord[1][0][0], coord[1][0][1], coord[1][1][0], coord[1][1][1]);
    return 0;
}
