/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <string>
#include <set>

using namespace std;

int n;
set<int> l, r;
map<int, int> p, q;

int main()
{
    freopen("heels.in", "r", stdin);
    freopen("heels.out", "w", stdout);

    scanf("%d\n", &n);

    for (int k = 0; k < n; k++) {
        int a;
        scanf("%d ", &a);
        l.insert(a);
        p[a]++;
    }
    scanf("\n");
    for (int k = 0; k < n; k++) {
        int a;
        scanf("%d ", &a);
        r.insert(a);
        q[a]++;
    }

    set<int> heels;
    set_intersection(l.begin(), l.end(), r.begin(), r.end(),
                     std::inserter(heels, heels.begin()));

    int answer = 0;

    set<int>::iterator it;
    for (it = heels.begin(); it != heels.end(); it++) {
        answer += (p[*it] > q[*it]) ? q[*it] : p[*it];
    }

    cout << answer << endl;

    return 0;
}
