/* GCC */

#include <windows.h>
#include <iostream.h>
#include <fstream.h>

using namespace std;

int main()
{
    int D;
    bool Answer = true;
    ifstream fin("awesome.in",std::ios_base::in);
    fin >> D;
    fin.close();

    int InitialD = D;

    //exception
    if (D == 1)
    {
        ofstream fout("awesome.out",std::ios_base::out);
        fout << 1;
        fout.close();

        return 0;
    }

    unsigned char Digits[200000];
    int top = -1;

    //Split into simple numbers while possible
    bool Divided = true;
    while (Divided)
    {
        Divided = false;
        for (int div = 2; div < 10; div++)
            if (D%div == 0)
            {
                D /= div;
                Digits[++top] = div;
                Divided = true;
                break;
            }
    }

    //for index sorting
    int Values[10] = {0};//[0] is practically empty

    if (D >= 10)
        Answer = false;
    else
    {
        for (int i = 0; i <= top; i++)
            Values[Digits[i]]++;

        int Sum = 0;
        for (int i = 0; i <= top; i++)
            Sum += Digits[i];

        Values[1] = InitialD-Sum;
    }

    ofstream fout("awesome.out",std::ios_base::out);
    if (Answer)
    {
        for (int Value = 9; Value >= 1; Value--)
            for (int i = 0; i < Values[Value]; i++)
                fout << Value;
    }
    else fout << 0;
    fout.close();

    return 0;
}
