/* GCC */

#include <windows.h>
#include <iostream.h>
#include <fstream.h>

using namespace std;

int main()
{
    int N;
    ifstream fin("heels.in",std::ios_base::in);
    fin >> N;

    int *A = new int[N];
    int *B = new int[N];

    for (int i = 0; i < N; i++)
        fin >> A[i];
    for (int i = 0; i < N; i++)
        fin >> B[i];

    fin.close();

    bool Used[200000];

    for (int i = 0; i < N; i++)
        Used[i] = false;

    int Answer = 0;

    for (int q = 0; q < N; q++)
    {
        for (int w = 0; w < N; w++)
        {
            if (!Used[w])
                if (B[w] == A[q])
                {
                    Used[w] = true;
                    Answer++;
                    break;
                }
        }
    }

    ofstream fout("heels.out",std::ios_base::out);
    fout << Answer;
    fout.close();

    delete [] A;
    delete [] B;

    return 0;
}
