{ Free Pascal }
Program heels;

Const Nmax = 200000;

Type Tmas = array[1..Nmax] of byte;


Procedure swap(var a, b : byte);
Var h : byte;
begin
        h := a;
        a := b;
        b := h;
end;


Procedure qsort(var mas : Tmas;var n : longword);
        Procedure sort(l, r : longword);
        Var ll, rr, h : longword;
        begin
                ll := l;
                rr := r;
               h := (l + r) div 2;
                repeat
                        while mas[ll] < mas[h] do inc(ll);
                        while mas[rr] > mas[h] do dec(rr);
                        if ll <= rr then
                        begin
                                swap(mas[ll], mas[rr]);
                                inc(ll);
                                dec(rr);
                        end;
                until rr < ll;
                if ll < r then sort(ll, r);
                if rr > l then sort(l, rr);
        end;
Begin
        sort(1, n);
end;

Procedure input(var mas1, mas2 : Tmas;var n : longword);
Var f : text;
        i : longword;
Begin
        assign(f, 'heels.in');
        reset(f);
        read(f, n);
        for i := 1 to n do read(f, mas1[i]);
        for i := 1 to n do read(f, mas2[i]);
        close(f);
end;

function res(var mas1, mas2 : Tmas;var n : longword) : longword;
Var i, j, r : longword;
Begin
        i := 1;
        j := 1;
        r := 0;
        while (i <= n) and (j <= n) do
        begin
                while (mas1[i] < mas2[j]) and (i < n) do inc(i);
                while (mas2[j] < mas1[i]) and (j < n) do inc(j);
                if mas1[i] = mas2[j] then
                begin
                        inc(r);
                        inc(i);
                        inc(j);
                end;
        end;
        res := r;
end;

procedure output(res : longword);
Var f : text;
Begin
        assign(f, 'heels.out');
        rewrite(f);
        writeln(f, res);
        close(f);
end;

Var mas1, mas2 : Tmas;
        n : longword;
Begin
        input(mas1, mas2, n);
        qsort(mas1, n);
        qsort(mas2, n);
        output(res(mas1, mas2, n));
end.
