/* GCC */
#define _USE_MATH_DEFINES
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <cstdlib>
#include <complex>
#include <cstdio>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef complex <double> cd;

#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sd second
#define fs first

const bool db=false;

#define inf 1000000007
#define nmax 210000
#define mmax 100000
#define eps 1e-6

ll left_shoe[nmax],right_shoe[nmax];

int main()
{
    freopen("heels.in","r",stdin); freopen("heels.out","w",stdout);
    ll n;
    cin>>n;
    for (ll i=1;i<=n;i++)
        cin>>left_shoe[i];
    for (ll i=1;i<=n;i++)
        cin>>right_shoe[i];
    sort(left_shoe+1,left_shoe+n+1);
    sort(right_shoe+1,right_shoe+n+1);
    ll l,r,res=0;
    l=r=1;
    while (l <=n && r<=n)
    {
        if (left_shoe[l]==right_shoe[r])
            res++,l++,r++;
        else if (left_shoe[l]<right_shoe[r])
        l++;
        else r++;
    }
    cout<<res<<"\n";
    return 0;
}
