/* GCC */
#include <fstream>
#include <map>

int main(void)
{
    unsigned long n = 0;
    unsigned long temp = 0;
    std::ifstream in("heels.in");
    in >> n;
    std::map<unsigned long, unsigned long> left;
    std::map<unsigned long, unsigned long> right;
    for(unsigned long i = 0; i < n; i++)
    {
                 in >> temp;
                 left[temp]++;
    }
    for(unsigned long i = 0; i < n; i++)
    {
                 in >> temp;
                 right[temp]++;
    }
    in.close();
    unsigned long result = 0;
    for(std::map<unsigned long, unsigned long>::iterator it = left.begin(); it != left.end(); it++)
                 result += std::min(it->second, right[it->first]);
    std::ofstream out("heels.out");
    out << result << std::endl;
    out.close();
    return 0;
}
