/* GCC */
#include <fstream>

int main(void)
{
    size_t n = 0;
    size_t sq1lux = 0, sq1luy = 0, sq1rdx = 0, sq1rdy = 0, sq2lux = 0, sq2luy = 0, sq2rdx = 0, sq2rdy = 0;
    std::ifstream in("squares.in");
    in >> n;
    char** ch = new char*[n];
    bool set = false;
    for(size_t i = 0; i < n; i++)
    {
               ch[i] = new char[n];
               for(size_t j = 0; j < n; j++)
               {
                          in >> ch[i][j];
                          if(!set && (ch[i][j] == '#'))
                          {
                                  sq1luy = i;
                                  sq1lux = j;
                                  set = true;
                          }
               }
    }
    in.close();
    size_t sq1side = 0, sq1side_v1 = 0, sq1side_v2 = 0;
    for(size_t j = sq1lux; j < n; j++)
    {
               if(ch[sq1luy][j] == '#')
                                sq1side_v1++;
               else break;
    }
    for(size_t i = sq1luy; i < n; i++)
    {
               if(ch[i][sq1lux] == '#')
                                sq1side_v2++;
               else break;
    }
    sq1side = std::min(sq1side_v1, sq1side_v2);
    sq1rdx = sq1lux + sq1side - 1;
    sq1rdy = sq1luy + sq1side - 1;
    ch[sq1luy][sq1lux] = '.';
    for(size_t i = sq1luy + 1; i < sq1rdy; i++)
    {
               if((sq1lux == 0 || (ch[i][sq1lux-1] == '.')) || ch[i][sq1lux+1] == '.')
                          ch[i][sq1lux] = '.';
               if((sq1rdx == n-1 || (ch[i][sq1rdx+1] == '.')) || ch[i][sq1rdx-1] == '.')
                          ch[i][sq1rdx] = '.';
    }
    for(size_t j = sq1lux + 1; j < sq1rdx; j++)
    {
               if((sq1luy == 0 || (ch[sq1luy-1][j] == '.')) || ch[sq1luy+1][j] == '.')
                          ch[sq1luy][j] = '.';
               if((sq1rdy == n-1 || (ch[sq1rdy+1][j] == '.')) || ch[sq1rdy-1][j] == '.')
                          ch[sq1rdy][j] = '.';
    }
    if((sq1luy == 0 || (ch[sq1luy-1][sq1rdx] == '.')) ||(sq1rdx == n-1 || (ch[sq1luy][sq1rdx+1] == '.')))
               ch[sq1luy][sq1rdx] = '.';
    if((sq1rdy == n-1 || (ch[sq1rdy+1][sq1lux] == '.')) || (sq1lux == 0 || (ch[sq1rdy][sq1rdx-1] == '.')))
               ch[sq1rdy][sq1lux] = '.';
    if((sq1rdx == n-1 || (ch[sq1rdy][sq1rdx+1])) || (sq1rdy == n-1 || (ch[sq1rdy+1][sq1rdx]) == '.'))
               ch[sq1rdy][sq1rdx] = '.';
    set = false;
    for(size_t i = sq1luy; i < n; i++)
    {
               for(size_t j = 0; j < n; j++)
               {
                          if(ch[i][j] == '#')
                          {
                                      sq2luy = i;
                                      set = true;
                                      break;
                          }
               }
               if(set)
                      break;
    }
    set = false;
    for(size_t j = 0; j < n; j++)
    {
               for(size_t i = 0; i < n; i++)
               {
                          if(ch[i][j] == '#')
                          {
                                      sq2lux = j;
                                      set = true;
                                      break;
                          }
               }
               if(set)
                      break;
    }
    set = false;
    for(size_t i = n-1; i > 0; i--)
    {
               for(size_t j = 0; j < n; j++)
               {
                          if(ch[i][j] == '#')
                          {
                                      sq2rdy = i;
                                      set = true;
                                      break;
                          }
               }
               if(set)
                      break;
    }
    set = false;
    for(size_t j = n-1; j > 0; j--)
    {
               for(size_t i = 0; i < n; i++)
               {
                          if(ch[i][j] == '#')
                          {
                                      sq2rdx = j;
                                      set = true;
                                      break;
                          }
               }
               if(set)
                      break;
    }
    if(sq2rdx-sq2lux > sq2rdy-sq2luy)
    {
                     if(sq2rdy+1 == sq1rdy || sq2rdy+1 == sq1luy)
                                 sq2rdy++;
                     else
                                 sq2luy--;
    }
    else if(sq2rdy-sq2luy > sq2rdx-sq2lux)
    {
         if(sq2rdx+1 == sq1rdx || sq2rdx+1 == sq1lux)
             sq2rdx++;
         else
             sq2lux--;
    }
    else if(ch[sq2luy][sq2lux] == '.' && ch[sq2rdy-1][sq2rdx] == '.' && ch[sq2rdy][sq2rdx-1] == '.' && ch[sq2rdy][sq2lux] == '#' && ch[sq2luy][sq2rdx] == '#')
    {
                          sq2lux--;
                          sq2luy--;
    }
    else if(ch[sq2rdy][sq2rdx] == '.' && ch[sq2luy+1][sq2lux] == '.' && ch[sq2luy][sq2lux+1] == '.' && ch[sq2luy][sq2rdx] == '#' && ch[sq2rdy][sq2lux] == '#')
    {
                          sq2rdx++;
                          sq2rdy++;
    }
    if(sq2luy+sq2lux+sq2rdy+sq2rdx == 0)
    {
                                   sq2luy = sq1luy;
                                   sq2lux = sq1lux;
                                   sq2rdy = sq1rdy;
                                   sq2rdx = sq1rdx;
    }
    unsigned long long indicate_1 = sq1lux*1000000000 + sq1luy*1000000 + sq1rdx*1000 + sq1rdy;
    unsigned long long indicate_2 = sq2lux*1000000000 + sq2luy*1000000 + sq2rdx*1000 + sq2rdy;
    std::ofstream out("squares.out");
    if(indicate_1 < indicate_2)
    {
                  out << sq1lux+1 << ' ' << sq1luy+1 << ' ' << sq1rdx+1 << ' ' << sq1rdy+1 << std::endl
                      << sq2lux+1 << ' ' << sq2luy+1 << ' ' << sq2rdx+1 << ' ' << sq2rdy+1 << std::endl;
    }
    else
    {
        out << sq2lux+1 << ' ' << sq2luy+1 << ' ' << sq2rdx+1 << ' ' << sq2rdy+1 << std::endl
            << sq1lux+1 << ' ' << sq1luy+1 << ' ' << sq1rdx+1 << ' ' << sq1rdy+1 << std::endl;
    }
    out.close();
    for(size_t i = 0; i < n; i++)
               delete[] ch[i];
    delete[] ch;
    return 0;
}
