/* GCC */

#include <cstdio>
#include <algorithm>

using namespace std;

struct Square
{
    Square (int x_ = 0, int y_ = 0, int x2_ = 0, int y2_ = 0)
    {
        x = x_, y = y_, x2 = x2_, y2 = y2_;
    }
    int x, y, x2, y2;
};

const int nMax = 1016;

int M [nMax][nMax];
Square s1, s2;

void find_square (int x, int y)
{
    int l = 2;
    start:
    while ( M[x+l][y] )
    {
        for (int i = 1; i <= l; i++)
            if ( M[x+i][y] == 0 )
            {
                l++;
                goto start;
            }
        for (int i = 1; i <= l; i++)
            if ( M[x+l][y+i] == 0 )
            {
                l++;
                goto start;
            }
        for (int i = 1; i <= l; i++)
            if ( M[x+i][y+l] == 0 )
            {
                l++;
                goto start;
            }
        for (int i = 1; i <= l; i++)
            if ( M[x][y+i] == 0 )
            {
                l++;
                goto start;
            }
        if ( s1.x == 0 )
            s1.x = x, s1.y = y, s1.x2 = x+l, s1.y2 = y+l, l++;
        else if ( s2.x == 0 )
            s2.x = x, s2.y = y, s2.x2 = x+l, s2.y2 = y+l, l++;
        else
            return;
    }
}

int main ()
{
    freopen ("squares.in", "r", stdin);
    freopen ("squares.out", "w", stdout);
    int n, k = 0;

    scanf ("%d\n", &n);

    for (int y = 1; y <= n; y++)
        for (int x = 1; x <= n; x++)
        {
            char c;
            scanf ("%c ", &c);
            M[x][y] = (c == '#');
            k += ( c == '#' );
        }

    for (int y = 1; y <= n; y++)
        for (int x = 1; x <= n && s2.x == 0; x++)
            if ( M[x][y] )
                find_square (x, y);
    if (s2.x == 0)
        s2 = s1;
    if ( s1.x > s2.x )
        swap (s1, s2);
    if (s1.y > s2.y && s1.x == s2.x)
        swap (s1, s2);
    if (s1.x2 > s2.x2 && s1.y == s2.y && s1.x == s2.x)
        swap (s1, s2);
    if (s1.y2 > s2.y2 && s1.x2 > s2.x2 && s1.y == s2.y && s1.x == s2.x)
        swap (s1, s2);

    printf ("%d %d %d %d\n", s1.x, s1.y, s1.x2, s1.y2);
    printf ("%d %d %d %d\n", s2.x, s2.y, s2.x2, s2.y2);

    return 0;
}
