/* GCC */
#include <iostream>
#include <fstream>
#include <cstring>
#include <vector>

using namespace std;

typedef unsigned int uint;

uint * field, n;

struct square
{
    uint x, y, a;
};
vector<square> arr;

int main()
{
    uint n2, c = 0;
    ifstream ifs("squares.in");
    ifs >> n;
    n2 = n*n;

    field = new uint [n2];
    //uint *f = &field[0][0];
    memset(field, 0, n2*sizeof(uint));
    char ch;
    do
    {
        ch = ifs.get();
        if(ch == ' ' || ch == '\r' || ch == '\n') continue;
        else if(ch == '#') field[c] = 1;
        ++c;
    } while(ch == ' ' || ch == '.' || ch == '#' || ch == '\r' || ch == '\n');
    ifs.close();

    ofstream ofs("squares.out");
    for(int j = 0; j < n; ++j)
        for(int i = 0; i < n; ++i)
    {
        //ofs<<"["<<i<<","<<j<<"]\n";
        if(field[n*j+i] == 0) continue;
        //ofs<<"ok-1\n";
        if(i != n-1 && field[n*j+i+1] == 0) continue;
        //ofs<<"ok0\n";
        square sq;
        sq.x = i;
        sq.y = j;
        sq.a = 1;
        for(; sq.a < n-i && field[n*j+i+sq.a] == 1; ++sq.a);
        --sq.a;
        //ofs<<sq.a<<"\n";
        if(field[n*sq.y+sq.x+sq.a] == 1 &&
           field[n*(sq.y+sq.a)+sq.x] == 1 &&
           field[n*(sq.y+sq.a)+sq.x+sq.a] == 1 &&
           sq.a > 1) {
               //++sq.a;
                arr.push_back(sq);
            //ofs<<"ok2\n";
           }
    }
    if(arr.size() == 1)
    {
        ofs << 1+arr[0].x << " " << 1+arr[0].y << " " << 1+arr[0].x+arr[0].a << " "<< 1+arr[0].y+arr[0].a << endl;
        ofs << 1+arr[0].x << " " << 1+arr[0].y << " " << 1+arr[0].x+arr[0].a << " "<< 1+arr[0].y+arr[0].a;
        ofs.close();
        return 0;
    }

    vector<square> final;
    uint min_a = -1, idx = 0;
    for(uint i = 0; i < arr.size(); ++i)
    {
        square &sq = arr[i];
        //ofs << sq.a << endl;
        for(uint u1 = 0; u1 <= sq.a; ++u1)
            if(field[n*sq.y+sq.x+u1] == 0 || field[n*(sq.y+sq.a)+sq.x+u1] == 0)
                goto out;
        for(uint u1 = 0; u1 <= sq.a; ++u1)
            if(field[n*(sq.y+u1)+sq.x] == 0 || field[n*(sq.y+u1)+sq.x + sq.a] == 0)
                goto out;
        if(sq.a < min_a){
            min_a = sq.a;
            idx = i;
        }
        final.push_back(sq);
        //ofs << sq.x << " " << sq.y << " " << sq.x+sq.a << " "<< sq.y+sq.a << endl;
out:
    ;
    }
    if(final.size() == 3)
        final.erase(final.begin()+idx);
    square &s1 = final[0], &s2 = final[1];
    if(s1.x > s2.x || (s1.x == s2.x && s1.y > s2.y)
       || (s1.x == s2.x && s1.y == s2.y && s1.x+s1.a > s2.x+s2.a)
    || (s1.x == s2.x && s1.y == s2.y && s1.x+s1.a == s2.x+s2.a && s1.y+s1.a > s2.y+s2.a))
    {
        ofs << 1+s2.x << " " << 1+s2.y << " " << 1+s2.x+s2.a << " "<< 1+s2.y+s2.a << endl;
        ofs << 1+s1.x << " " << 1+s1.y << " " << 1+s1.x+s1.a << " "<< 1+s1.y+s1.a;
    }
    else
        {
        ofs << 1+s1.x << " " << 1+s1.y << " " << 1+s1.x+s1.a << " "<< 1+s1.y+s1.a << endl;
        ofs << 1+s2.x << " " << 1+s2.y << " " << 1+s2.x+s2.a << " "<< 1+s2.y+s2.a;
    }

    ofs.close();
    //cin.get();

}
