/* GCC */
#include <fstream>
#include <vector>

using namespace std;

int main()
{
    ifstream fin("heels.in");
    int n;
    int k;
    fin >> n;
    vector<int> lefts(n);
    vector<int> rights(n);
    int pairs = 0;
    for (int i = 0; i < n; i++) {
        fin >> k;
        lefts[i] = k;
    }
    for (int i = 0; i < n; i++) {
        fin >> k;
        rights[i] = k;
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (lefts[i] == rights[j]) {
                pairs++;
                lefts[i] = lefts[i] ^ -1;
                rights[j] = rights[i] ^ -2;
            }
        }
    }

    ofstream fout("heels.out");
    fout << pairs << endl;
}
