/* GCC */

#define maxn 200000

#include <stdio.h>
#include <algorithm>

using namespace std;

int l[maxn], r[maxn];

int main()
{
    freopen("heels.in", "r", stdin);
    freopen("heels.out", "w", stdout);
    int n, npair = 0;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        scanf("%d", &l[i]);
    for (int i = 0; i < n; i++)
        scanf("%d", &r[i]);
    sort(l, l + n);
    sort(r, r + n);
    int i = 0, j = 0;
    while ((i < n) && (j < n))
    {
        if (l[i] == r[j])
        {
            npair++;
            i++;
            j++;
        }
        else
            if (l[i] < r[j])
                i++;
            else
                j++;
    }
    printf("%d\n", npair);
    return 0;
}
