/* GCC */
#include <stdio.h>
#include <iostream>
#include <vector>
#include <map>

using namespace std;

#define H_MAX 1000

int lheights[H_MAX];
int rheights[H_MAX];
vector<int> lhuge;
vector<int> rhuge;
map<int,int> lmap;
map<int,int> rmap;
int ans = 0;
int maxh = 0;
int maxnormal = 0;

int main() {
    freopen("heels.in", "r",stdin);
    freopen("heels.out","w",stdout);
    int n = 0;
    cin >> n;
    for (int i = 0; i < H_MAX; ++i) {
        lheights[i] = 0;
        rheights[i] = 0;
    }

    for (int i = 0; i < n; ++i) {
        int h = 0;
        cin >> h;
        if (h < H_MAX){
            maxnormal = max(maxnormal,h);
            lheights[h-1]++;
        } else {
            lhuge.push_back(h);
            lmap[h]++;
        }
        maxh = max(maxh,h);
    }
    for (int i = 0; i < n; ++i) {
        int h = 0;
        cin >> h;
        if (h < H_MAX){
            rheights[h-1]++;
        } else {
            rhuge.push_back(h);
            rmap[h]++;
        }
    }

    for (int i = 0; i < min(maxh,maxnormal); ++i) ans += min(lheights[i],rheights[i]);

    if (maxh > H_MAX) {
        for (map<int,int>::iterator it = lmap.begin(); it != lmap.end(); ++it) {
            ans += min(it->second,rmap[it->first]);
        }
    }

    printf("%d\n",ans);

    return 0;
}
