/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <memory.h>
#include <vector>
using namespace std;
#define ll long long
#define mp make_pair
#define pii pair<int,int>
#define maxn 1010

int n, cnt;
int a[maxn][maxn];
int u[maxn][maxn];

vector<pii > q,w;
vector<pair<pii,pii > > v;

void writeout(pii x,pii y)
{
    printf("%d %d %d %d\n",x.first,x.second,y.first,y.second);
}

bool check(pii x,pii y)
{
    if(x.first>=y.first || x.second>=y.second) return false;
    for(int i=x.first;i<=y.first;++i)
        if(!a[i][x.second] || !a[i][y.second]) return false;

    for(int i=x.second;i<=y.second;++i)
        if(!a[x.first][i] || !a[y.first][i]) return false;

    return true;
}

bool check2(pii x,pii y)
{
    for(int i=x.first;i<=y.first;++i)
    {
        if(a[i][x.second]){
            a[i][x.second]=0;
            u[i][x.second]=1;
            cnt--;
        }
        if(a[i][y.second]){
            a[i][y.second]=0;
            u[i][y.second]=1;
            cnt--;
        }
    }
    for(int i=x.second;i<=y.second;++i)
    {
        if(a[x.first][i]){
            a[x.first][i]=0;
            u[x.first][i]=1;
            cnt--;
        }
        if(a[y.first][i]){
            a[y.first][i]=0;
            u[y.first][i]=1;
            cnt--;
        }
    }
    bool good = cnt==0;

    for(int i=x.first;i<=y.first;++i)
    {
        if(u[i][x.second]){
            a[i][x.second]=1;
            u[i][x.second]=0;
            cnt++;
        }
        if(u[i][y.second]){
            a[i][y.second]=1;
            u[i][y.second]=0;
            cnt++;
        }
    }
    for(int i=x.second;i<=y.second;++i)
    {
        if(u[x.first][i]){
            a[x.first][i]=1;
            u[x.first][i]=0;
            cnt++;
        }
        if(u[y.first][i]){
            a[y.first][i]=1;
            u[y.first][i]=0;
            cnt++;
        }
    }
    return good;
}

void maybe(pii x,pii y)
{
    v.push_back(mp(x,y));
}

int square(pii x,pii y)
{
    return (y.first-x.first+1)*(y.second-x.second+1);
}

bool cmp(pair<pii,pii > a,pair<pii,pii > b)
{
    return square(a.first,a.second)>square(b.first,b.second);
}

vector<pair<pii,pii > > s;

int main()
{
    freopen("squares.in","r",stdin);
    freopen("squares.out","w",stdout);
    scanf("%d\n",&n);
    for(int i=1;i<=n;++i)
        for(int j=1;j<=n;++j)
        {
            char c;
            if(j<n)
            scanf("%c ",&c);
            else scanf("%c\n",&c);
            if(c=='.') a[i][j]=0;
            else a[i][j]=1, cnt++;
        }
    for(int i=1;i<=n;++i)
        for(int j=1;j<=n;++j)
        {
            if(a[i][j+1] && a[i+1][j]) q.push_back(mp(i,j));
            if(a[i][j-1] && a[i-1][j]) w.push_back(mp(i,j));
        }
    for(int i=0;i<q.size();++i)
        for(int j=0;j<w.size();++j)
            if(check(q[i],w[j])) maybe(q[i],w[j]);
    sort(v.begin(),v.end(),cmp);
    s.push_back(v[0]);
    if(v.size()==1) s.push_back(v[0]);
    else{
            pii x = v[0].first;
            pii y = v[0].second;
            for(int i=x.first;i<=y.first;++i)
            {
                a[i][x.second]=0;
                cnt--;
                a[i][y.second]=0;
                cnt--;
            }
            for(int i=x.second+1;i<=y.second-1;++i)
            {
                a[x.first][i]=0;
                cnt--;
                a[y.first][i]=0;
                cnt--;
            }
            for(int i=1;i<v.size();++i)
                if(check2(v[i].first,v[i].second))
                {
                    s.push_back(v[i]);
                    break;
                }
    }
    swap(s[0].first.first,s[0].first.second);
    swap(s[0].second.first,s[0].second.second);
    swap(s[1].first.first,s[1].first.second);
    swap(s[1].second.first,s[1].second.second);
    sort(s.begin(),s.end());
    writeout(s[0].first,s[0].second);
    writeout(s[1].first,s[1].second);
}
