/* GCC */

#include <fstream>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> dilns;

bool simple(int n) {
    bool sim = true;
    for (int d = n / 2; d > 1; d--) {
        if (n % d == 0) {
            sim = false;
            break;
        }
    }
    return sim;
}
     

int dilnk(int tempNumb) {
    int diln = tempNumb / 2;
    
    while (tempNumb > 0) {
        if (tempNumb % diln == 0) {
           tempNumb = tempNumb / diln;
           
           if (simple(diln)) { 
              dilns.push_back(diln);
           }
           else {
               dilnk(diln);    
           }
        }
        else {
           diln--;  
        }  
        
        if (diln < 2) {
           break;
        }
    }
}

int main() {
    bool wrong = false;
    
    int defaultNumb;
    int resultNumb = 0;
    int sum = 0;
    
    ifstream fin("awesome.in");
    ofstream fout("awesome.out");
    
    fin >> defaultNumb;
    
    dilnk(defaultNumb);
    
    if (simple(defaultNumb)) {
        if (defaultNumb > 9) {
            wrong = true;
        }
        else {
            dilns.push_back(defaultNumb);      
        }
    }
    
   
    for (int i = 0; i < dilns.size(); i++) {
        sum += dilns[i];
        if (dilns[i] > 9) {
            wrong = true;
        }
    }
    
    if (!wrong) {
       for (int i = 0; i < dilns.size(); i++) {
          fout << dilns[i];
       }
    
       for (int i =0; i < defaultNumb - sum; i++) {
          fout << "1";
       }
       
    }
    else {
       fout << 0;
    }
    
    fout << endl;
    
    fin.close();
    fout.close();
    
    return 0;
}
