/* GCC */

#include <fstream>
#include <algorithm>

using namespace std;

int main() {
    int n;
    int counter = 0;
    
    ifstream fin("heels.in");
    ofstream fout("heels.out");
    
    fin >> n;
    
    if (n > 1000) {  
          int leftCount[1001];
          int rightCount[1001];
    
          memset(leftCount, 0, sizeof(leftCount));    
          memset(rightCount, 0, sizeof(rightCount));
    
          for (int i = 0; i < n; i++) {
              int k;
              fin >> k;
              leftCount[k]++;
          }
    
          for (int i = 0; i < n; i++) {
              int k;
              fin >> k;
              rightCount[k]++;
          }
    
          for (int i = 0; i < 1001; i++) {
              counter += min(leftCount[i], rightCount[i]);
          }   
    }
    else {
         
          long lnumbs[n];
          long rnumbs[n];
          
          bool rightUsedNums[n];  
          bool leftUsedNums[n];
          
          memset(lnumbs, 0, sizeof(lnumbs));    
          memset(rnumbs, 0, sizeof(rnumbs));
          
          memset(rightUsedNums, 0, sizeof(rightUsedNums));
          memset(leftUsedNums, 0, sizeof(leftUsedNums));
          
          for (int i = 0; i < n; i++) {
              fin >> lnumbs[i];
          }
          
          for (int i = 0; i < n; i++) {
              fin >> rnumbs[i];
          }
          
          for (int i = 0; i < n; i++) {
              for (int j = 0; j < n; j++) {
                  if (lnumbs[i] == rnumbs[j] && !rightUsedNums[j] && !leftUsedNums[i]) {
                      counter++;
                      
                      //fout << rnumbs[j] << " "<< lnumbs[i] << " " << endl;
                      rightUsedNums[j] = true;
                      leftUsedNums[i] = true;
                  }
              }
          }
    }
    
    fout << counter << endl;
    
    fin.close();
    fout.close();
    return 0;
}
