/* GCC */

#include <iostream>
#include <valarray>
#include <cstdio>

using namespace std;

int compare(const void * x1, const void * x2)
{
    return(*(int*)x1 - *(int*)x2);
}

int main()
{
    freopen("heels.in","r",stdin);
    freopen("heels.out","w",stdout);

    int n;
    cin >> n;
    int arr1[n];
    int arr2[n];
    for (int i = 0; i < n; i++)
    {
        cin >> arr1[i];
    }
    for (int i = 0; i < n; i++)
    {
        cin >> arr2[i];
    }

    qsort(arr1,n,sizeof(int),compare);
    qsort(arr2,n,sizeof(int),compare);

    int k = 0, l = 0, countN = 0;

    while ((k <= n) && (l <= n))
    {
        if (arr1[k] > arr2[l])
        {
            l++;
        }
        else if (arr1[k] < arr2[l])
        {
            k++;
        }
        else
        {
            l++; k++;
            countN ++;
        }
    }

    cout << countN << endl;
}
