/* GCC */

#include <iostream>
#include <vector>
#include <fstream>
using namespace std;

void swaps(int &x,int &y)
{
   int z = x;
   x = y;
   y = z;
}

void recsort(int be,int en,vector <int> &a)
{
    int t = (be + en) / 2;
    int x = a[t];
    t = be;
    int k = be - 1;
    int m = en + 1;
    while (t < m)
    {
        if (a[t] > x)
        {
            m--;
            swaps(a[t],a[m]);
        }
        else
        {
            if (a[t] < x)
            {
                k++;
                swaps(a[t],a[k]);
            }
            t++;
        }
    }
    if (k > be) recsort(be, k, a);
    if (m < en) recsort(m, en, a);
}

int main()
{
    ifstream fin;
    fin.open ("heels.in");
    int n;
    fin >> n;
    vector <int> a(n);
    vector <int> b(n);
    for (int t = 0; t < n; t++)
        fin >> a[t];
    for (int t = 0; t < n; t++)
        fin >> b[t];
    fin.close();

    recsort(0,n-1,a);
    recsort(0,n-1,b);
    int k = 0;
    int l = 0;
    int m = 0;
    while ((k < n) && (l < n))
    {
        if (a[k] == b[l])
        {
            k++;
            l++;
            m++;
        }
        if (a[k] < b[l])
            k++;
        else l++;
    }

    ofstream fout;
    fout.open("heels.out");
    fout << m << endl;
    fout.close();

    return 0;
}
