/* GCC */
#include <fstream>
#include <algorithm>
#include <iostream>

using namespace std;

void read_file(ifstream& fin, long* or_arr, long* mar_arr, const long& size) {
     long i(0);
     for( ; i < size; i++) fin >> or_arr[i];
     i = 0;
     for( ; i < size; i++) fin >> mar_arr[i];
     fin.close();
}
inline void first_common(long* or_arr, long* mar_arr, long i, long& j, const long& size) {
    while(or_arr[i] != mar_arr[j] && j < size) j++;
}
int main(int argv, char** argc) {
    long size;
    ifstream fin("heels.in");
    fin >> size;
    long or_arr[size + 1], mar_arr[size];
    or_arr[size] = -1;
    read_file(fin, or_arr, mar_arr, size);
    sort(or_arr, or_arr + size);
    sort(mar_arr, mar_arr + size);
    long cnt(0), or_cnt(1), mar_cnt(1), i(0), jj(0);
    if(size == 1) {
        ofstream fout("heels.out");
        if(or_arr[0] == mar_arr[0]) {
            fout << 1 << '\n';
        }
        else { fout << 0 << '\n'; }
        fout.close();
    }
    else {
        while(i < size &&) {
            while(i + 1 < size + 1 && (or_arr[i] == or_arr[++i]) ) { or_cnt++; }
            jj = 0;
            first_common(or_arr, mar_arr, i - 1, jj, size);
            if(jj == size ) { continue; }
            while(jj + 1 < size && (mar_arr[jj] == mar_arr[++jj]) ) { mar_cnt++; }
            cnt += min(or_cnt, mar_cnt);
            or_cnt = mar_cnt = 1;
        }
        ofstream fout("heels.out");
        fout << cnt << '\n';
        fout.close();
    }
    return 0;
}
