/* GCC */
#define _USE_MATH_DEFINES
#include <iostream>
#include <algorithm>
#include <memory.h>
#include <fstream>
#include <sstream>
#include <cstring>
#include <cstdlib>
#include <complex>
#include <cstdio>
#include <vector>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef complex <double> cd;

#define mp make_pair
#define pb push_back
#define ppb pop_back
#define sd second
#define fs first

const bool db=false;

#define inf 1000000007
#define nmax 1100
#define mmax 100000
#define eps 1e-6

ll mas[nmax][nmax];
bool used[nmax][nmax];

ll ans[2][4];

int main()
{
    freopen("squares.in","r",stdin); freopen("squares.out","w",stdout);
    ll n;
    char c;
    cin>>n;
    for (ll i=1;i<=n;i++)
    {
        for (ll j=1;j<=n;j++)
        {
            cin>>c;
            if (c=='#')
                mas[i][j]=1;
            else mas[i][j]=0;
        }
    }
    ll res=0;
    bool use=1;
    for (ll i=1;i<=n && use;i++)
    {
        for (ll j=1;j<=n && use;j++)
        {
            if (mas[i][j]==1 && !used[i][j])
            {
                use=0;
                ll l,r,l1,r1;
                l1=r1=l=r=0;
                while (mas[i+l][j]==1 && mas[i][j+r]==1)
                    used[i+l][j]=used[i][j+r]=1,l++,r++;
                l--,r--;
                while (mas[i+l1][j+r]==1 && mas[i+l][j+r1]==1)
                    used[i+l1][j+r]=used[i+l][j+r1]=1,l1++,r1++;
                l1--;r1--;
                ans[res][0]=j;
                ans[res][1]=i;
                ans[res][2]=j+l;
                ans[res][3]=i+l;
                res++;
            }
        }
    }
    use=1;
    for (ll i=n;i>=1 && use;i--)
    {
        for (ll j=n;j>=1 && use;j--)
        {
            if (mas[i][j]==1 && !used[i][j])
            {
                use=0;
                ll l,r,l1,r1;
                l1=r1=l=r=0;
                while (mas[i-l][j]==1 && mas[i][j-r]==1)
                    used[i-l][j]=used[i][j-r]=1,l++,r++;
                l--,r--;
                while (mas[i-l1][j-r]==1 && mas[i-l][j-r1]==1)
                    used[i-l1][j-r]=used[i-l][j-r1]=1,l1++,r1++;
                l1--;r1--;
                ans[res][0]=j-l;
                ans[res][1]=i-l;
                ans[res][2]=j;
                ans[res][3]=i;
                res++;
            }
        }
    }
    if (use)
        for (ll i=0;i<4;i++)
            ans[1][i]=ans[0][i];
    ll i=0;
    while (i<4 && ans[0][i]==ans[1][i])
        i++;
    bool cmp=(i==4 || ans[0][i]<ans[1][i]);
    if (cmp)
    {
        for (ll i=0;i<=1;i++)
        {
            for (ll j=0;j<4;j++)
            {
                if (j!=3)
                    cout<<ans[i][j]<<" ";
                else cout<<ans[i][j]<<"\n";
            }
        }
    }
    else
    {
        for (ll i=1;i>=0;i--)
        {
            for (ll j=0;j<4;j++)
            {
                if (j!=3)
                    cout<<ans[i][j]<<" ";
                else cout<<ans[i][j]<<"\n";
            }
        }
    }
    return 0;
}
