/* GCC */
#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

const int NMAX = 200010;

int n, a[NMAX], b[NMAX], ans;

int main()
{
    freopen("heels.in", "r", stdin);
    freopen("heels.out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d", &a[i]);
    for (int i = 0; i < n; ++i)
        scanf("%d", &b[i]);
    sort(a, a + n);
    sort(b, b + n);

    ans = 0;
    int i = 0, j = 0;
    while (i < n && j < n)
    {
        if (a[i] == b[j])
            ++ans, ++i, ++j;
        else
            if (a[i] < b[j])
                ++i;
            else
                ++j;
    }
    printf("%d\n", ans);

    return 0;
}
